package com.excellapps.ideaactions;

import com.intellij.openapi.project.Project;
import com.intellij.openapi.actionSystem.AnAction;
import com.intellij.openapi.actionSystem.DataContext;
import com.intellij.openapi.actionSystem.AnActionEvent;
import com.intellij.openapi.actionSystem.DataConstants;

/**
 * Base class for all other actions.
 * 
 * @author Anki R Nelaturu
 */
public abstract class ISnippetAction extends AnAction {
    public SearchPanel getSearchPanel(final AnActionEvent event) {
        final DataContext dataContext = event.getDataContext();
        final Project project = (Project) dataContext.getData(DataConstants.PROJECT);
        if (project == null) {
            return null;
        }

        final ISnippetPlugin consolePlugin = (ISnippetPlugin) project.getComponent(ISnippetPlugin.class);
        if (consolePlugin == null) {
            return null;
        }

        return consolePlugin.getSearchPanel();
    }
}
