package com.excellapps.isnippet;

import java.util.ArrayList;

/**
 * Each search result is represented by this class.
 * If a result contains myltiple code samples, the list of the code samples should be provides
 * as ArrayLIst, so that the user can navigate using the Next and Previous buttons in the UI.
 * 
 * @author Anki R Nelaturu
 */
public interface ISnippet {
    /**
     * Brief summary of the search result.
     * Will be displayed in the results tree
     * @return
     */
    String getSummary();

    /**
     * HTML description of the search
     * @return the HTML content
     */
    String getHTML();

    /**
     * Stripped out codes snippets for easy view
     * @return List of code snippets
     */
    ArrayList<String> getCodeSnippets();
}
