package com.excellapps.isnippet;

import java.util.ArrayList;

/**
 * Plugin uses this interface to perform searches on a particular web site.
 *
 * @author Anki R Nelaturu
 */
public interface ISnippetSearchAgent {
    /**
     * Just a convenient method to display the source of the search in the results tree of iSnippet.
     *
     * @return brief text about the source from where the results were found
     */
    String getDisplayName();

    /**
     * The actual web URL
     *
     * @return url from where the results were found
     */
    String getHomePageURL();

    /**
     * Detailed description of the site providing these snippets.
     *
     * @return
     */
    String getDescription();

    /**
     * Performs the search for given keywords
     *
     * @param keywords - Array of keywords
     * @param detailedSearch - Up to the implementation to determine how the search should be performed.
     * @param inCodeOnly - If detailed search is enabled, user is willing to search in the code only
     * @return Matching araaylist of the ISnippets
     */
    ArrayList<ISnippet> matchingList(String[] keywords, boolean detailedSearch, boolean inCodeOnly);
}
