package com.excellapps.isnippet;

import com.excellapps.isnippet.impl.jda.JDASnippetSearchAgent;
import com.intellij.openapi.ui.Messages;

import java.util.ArrayList;

/**
 * Plugin gets the list of SearchAgents from this factory.
 * If there is a new implementation of SearchAgent, then it will be added here.
 * The actual plan is to be able to dynamically add the Agents through Settings.
 * But, couldn't implement it due to the deadlines at work :(
 * 
 * @author Anki R Nelaturu
 */
public class ISnippetSearchAgentsFactory {
    private static ArrayList<ISnippetSearchAgent> searchAgents;

    public static ArrayList<ISnippetSearchAgent> getSnippetManagers() {
        if(searchAgents == null) {
            searchAgents = new ArrayList<ISnippetSearchAgent>();

            try {
                searchAgents.add(new JDASnippetSearchAgent());
            } catch (Exception ex) {
                Messages.showErrorDialog(ex.getMessage(), "ISnippetSearchAgentsFactory");
            }
        }
        return searchAgents;
    }
}
